#!/usr/bin/perl

# controllo se il comando e' stato lanciato con la giusta opzione
if ( @ARGV != 2 || @ARGV[0] ne '-s')
{
	# stampo un messaggio di aiuto ed esco
	print "USAGE: ./banner.pl -s sile_grafico \n";
	exit(-1);
}

# leggo lo stile grafico da applicare
$stile=$ARGV[1];

# controllo se lo stile grafico esiste
if (!(-d "fonts/$stile"))
{
	# se lo stile non esiste stampo un messaggio ed esco
	print "WARNING: lo stile grafico $stile non esiste\n";
	exit(-1);
}

# leggo la stringa da stampare in formato grafico
print "Inserisci la stringa da trasformare: ";
$stringa=<STDIN>;
chomp($stringa);

# inizializzo un array in cui memorizzare il risultato
# il banner non e' altro che un array di stringhe
# una stringa per ogni linea del banner
@banner=(); 

# scorro i caratteri della stringa
for ($cur=0; $cur < length($stringa); $cur++)
{
	# prelevo un carattere dalla stringa
	$lettera=substr($stringa,$cur,1);
	# costruisco il nome del file relativo alla lettera grafica
	$file_lettera="fonts/$stile/$lettera.txt";

	# apro il file e controllo se esiste
	if (open(FILE_L, $file_lettera))
	{
		# salvo il cntenuto del file
		@tmp=<FILE_L>;
		chomp(@tmp);
		close(FILE_L);

		$id=0;
		# per ciascuna linea del carattere grafico
		foreach $row (@tmp)
		{
			# concateno le linee di ciascun carattere separandole da uno spazio
			$banner[$id] = $banner[$id] . $row . ' ';
			$id++;
		}
	}
	else
	{
		# se non trovo la lettera decido semplicemente di non stamparla
		# e di lanciare un warning
		print "WARNING: lettera $lettera non trovata \n";
	}
}

# alla fine stampo il banner
foreach (@banner)
{
	print "$_ \n";
}

